package com.ffm.test.hornetq;

import java.util.HashMap;
import java.util.Map;
import java.util.UUID;


import org.hornetq.api.core.HornetQException;
import org.hornetq.api.core.TransportConfiguration;
import org.hornetq.api.core.client.ClientConsumer;
import org.hornetq.api.core.client.ClientMessage;
import org.hornetq.api.core.client.ClientProducer;
import org.hornetq.api.core.client.ClientSession;
import org.hornetq.api.core.client.ClientSessionFactory;
import org.hornetq.api.core.client.HornetQClient;
import org.hornetq.api.core.client.MessageHandler;
import org.hornetq.integration.transports.netty.NettyConnectorFactory;


public class Caller {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		new Caller().callService();

	}

	
	public void callService() throws Exception {
		

        Map<String, Object> params = new HashMap<String, Object>();
        params.put("host", "localhost");
        params.put("port", 5447);

        TransportConfiguration transportConfiguration = 
            new TransportConfiguration(NettyConnectorFactory.class.getName(), params);                

        ClientSessionFactory factory1 =  HornetQClient.createClientSessionFactory(
        		transportConfiguration);

        final ClientSession session1 = factory1.createSession();
        final ClientProducer producer = session1.createProducer(Server.serviceName);

        Runnable client = new Runnable() {

			public void run() {
				
				int counter = 0;				
				while(true) {
		        String returnQueueName = Server.serviceName + UUID.randomUUID().toString()+counter;
		        
		        try {
			        session1.createTemporaryQueue(returnQueueName, returnQueueName);
			        ClientMessage message = session1.createMessage(false);
	
			        message.putStringProperty("generalmessage", "mymessage_"+counter);
			        message.putStringProperty("returnAddress", returnQueueName);
	
			        //System.out.println("return queue: ["+returnQueueName+"]");
			        ClientConsumer returnConsumer = session1.createConsumer(returnQueueName);			        			        
			        
			        returnConsumer.setMessageHandler(new CallbackHandler(returnQueueName, returnConsumer, session1));
	
			        producer.send(message);
			        } catch (Exception e) {
			        	e.printStackTrace();
			        }
			        
			        counter++;
				}
			}
        	
        };
        
        new Thread(client,"client1").start();

        session1.start();
        
	}

    class CallbackHandler implements MessageHandler {
    	
    	private String tempName;
    	ClientSession session;
    	ClientConsumer consumer;
    	public CallbackHandler(String aTempName, ClientConsumer aConsumer, ClientSession aSession) {
    		tempName = aTempName;
    		session = aSession;
    		consumer = aConsumer;
    	}

		public void onMessage(ClientMessage callbackMessage) {
						
	        String msg = callbackMessage.getStringProperty("return");
	        System.out.println("received return: "+msg);
	        
	        try {
	        	consumer.close();
				session.deleteQueue(tempName);
			} catch (HornetQException e) {
				e.printStackTrace();
			}
		}

    }
	
}
